// ************************************************************************ //
// The types declared in this file were generated from data read from the
// WSDL File described below:
// WSDL     : http://201.175.12.89/serviciointegracionpruebas/Timbrado.asmx?wsdl
//  >Import : http://201.175.12.89/serviciointegracionpruebas/Timbrado.asmx?wsdl>0
// Encoding : utf-8
// Version  : 1.0
// (10/7/2014 8:13:25 PM - - $Rev: 69934 $)
// ************************************************************************ //

unit Timbrado;

interface

uses Soap.InvokeRegistry, Soap.SOAPHTTPClient, System.Types, Soap.XSBuiltIns, Util;

const
  IS_OPTN = $0001;
  IS_UNBD = $0002;
  IS_NLBL = $0004;
  IS_REF  = $0080;


type

  // ************************************************************************ //
  // The following types, referred to in the WSDL document are not being represented
  // in this file. They are either aliases[@] of other types represented or were referred
  // to but never[!] declared in the document. The types from the latter category
  // typically map to predefined/known XML or Embarcadero types; however, they could also 
  // indicate incorrect WSDL documents that failed to declare or import a schema type.
  // ************************************************************************ //
  // !:string          - "http://www.w3.org/2001/XMLSchema"[Gbl]


               { "http://localhost/"[GblCplx] }

  // ************************************************************************ //
  // Namespace : http://localhost/
  // soapAction: http://localhost/%operationName%
  // transport : http://schemas.xmlsoap.org/soap/http
  // style     : document
  // use       : literal
  // binding   : TimbradoSoap
  // service   : Timbrado
  // port      : TimbradoSoap
  // URL       : http://201.175.12.89/serviciointegracionpruebas/Timbrado.asmx
  // ************************************************************************ //
  TimbradoSoap = interface(IInvokable)
  ['{BAAEDC2A-3AA4-3383-D3BE-235CC69DE407}']
    function  RegistraEmisor(const usuarioIntegrador: string; const rfcEmisor: string; const base64Cer: string; const base64Key: string; const contrasena: string): ArrayOfAnyType; stdcall;
    function  TimbraCFDI(const usuarioIntegrador: string; const xmlComprobanteBase64: string; const idComprobante: string): ArrayOfAnyType; stdcall;
    function  CancelaCFDI(const usuarioIntegrador: string; const rfcEmisor: string; const folioUUID: string): ArrayOfAnyType; stdcall;
    function  ObtieneCFDI(const usuarioIntegrador: string; const rfcEmisor: string; const folioUUID: string): ArrayOfAnyType; stdcall;
  end;

function GetTimbradoSoap(UseWSDL: Boolean=System.False; Addr: string=''; HTTPRIO: THTTPRIO = nil): TimbradoSoap;


implementation
  uses System.SysUtils;

function GetTimbradoSoap(UseWSDL: Boolean; Addr: string; HTTPRIO: THTTPRIO): TimbradoSoap;
const
  defWSDL = 'http://201.175.12.89/serviciointegracionpruebas/Timbrado.asmx?wsdl';
  defURL  = 'http://201.175.12.89/serviciointegracionpruebas/Timbrado.asmx';
  defSvc  = 'Timbrado';
  defPrt  = 'TimbradoSoap';
var
  RIO: THTTPRIO;
begin
  Result := nil;
  if (Addr = '') then
  begin
    if UseWSDL then
      Addr := defWSDL
    else
      Addr := defURL;
  end;
  if HTTPRIO = nil then
    RIO := THTTPRIO.Create(nil)
  else
    RIO := HTTPRIO;
  try
    Result := (RIO as TimbradoSoap);
    if UseWSDL then
    begin
      RIO.WSDLLocation := Addr;
      RIO.Service := defSvc;
      RIO.Port := defPrt;
    end else
      RIO.URL := Addr;
  finally
    if (Result = nil) and (HTTPRIO = nil) then
      RIO.Free;
  end;
end;


initialization
  { TimbradoSoap }
  InvRegistry.RegisterInterface(TypeInfo(TimbradoSoap), 'http://localhost/', 'utf-8');
  InvRegistry.RegisterDefaultSOAPAction(TypeInfo(TimbradoSoap), 'http://localhost/%operationName%');
  InvRegistry.RegisterInvokeOptions(TypeInfo(TimbradoSoap), ioDocument);
  { TimbradoSoap.RegistraEmisor }
  InvRegistry.RegisterMethodInfo(TypeInfo(TimbradoSoap), 'RegistraEmisor', '',
                                 '[ReturnName="RegistraEmisorResult"]', IS_OPTN);
  InvRegistry.RegisterParamInfo(TypeInfo(TimbradoSoap), 'RegistraEmisor', 'RegistraEmisorResult', '',
                                '[ArrayItemName="anyType"]');
  { TimbradoSoap.TimbraCFDI }
  InvRegistry.RegisterMethodInfo(TypeInfo(TimbradoSoap), 'TimbraCFDI', '',
                                 '[ReturnName="TimbraCFDIResult"]', IS_OPTN);
  InvRegistry.RegisterParamInfo(TypeInfo(TimbradoSoap), 'TimbraCFDI', 'TimbraCFDIResult', '',
                                '[ArrayItemName="anyType"]');
  { TimbradoSoap.CancelaCFDI }
  InvRegistry.RegisterMethodInfo(TypeInfo(TimbradoSoap), 'CancelaCFDI', '',
                                 '[ReturnName="CancelaCFDIResult"]', IS_OPTN);
  InvRegistry.RegisterParamInfo(TypeInfo(TimbradoSoap), 'CancelaCFDI', 'CancelaCFDIResult', '',
                                '[ArrayItemName="anyType"]');
  { TimbradoSoap.ObtieneCFDI }
  InvRegistry.RegisterMethodInfo(TypeInfo(TimbradoSoap), 'ObtieneCFDI', '',
                                 '[ReturnName="ObtieneCFDIResult"]', IS_OPTN);
  InvRegistry.RegisterParamInfo(TypeInfo(TimbradoSoap), 'ObtieneCFDI', 'ObtieneCFDIResult', '',
                                '[ArrayItemName="anyType"]');
  RemClassRegistry.RegisterXSInfo(TypeInfo(ArrayOfAnyType), 'http://localhost/', 'ArrayOfAnyType');

end.