unit Util;

interface

uses Soap.EncdDecd;

type
 ArrayOfAnyType = array of string;

function EncodeFile(const FileName: string): AnsiString;

implementation

uses
  System.Classes;

function EncodeFile(const FileName: string): AnsiString;
var
  stream: TMemoryStream;
begin
  stream := TMemoryStream.Create;
  try
    stream.LoadFromFile(Filename);
    result := EncodeBase64(stream.Memory, stream.Size);
  finally
    stream.Free;
  end;
end;

end.
